'* xPL VIOM
'*
'* Copyright (C) 2004 John Bent
'* http://www.xpl.myby.co.uk/
'*
'* This program is free software; you can redistribute it and/or
'* modify it under the terms of the GNU General Public License
'* as published by the Free Software Foundation; either version 2
'* of the License, or (at your option) any later version.
'* 
'* This program is distributed in the hope that it will be useful,
'* but WITHOUT ANY WARRANTY; without even the implied warranty of
'* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'* GNU General Public License for more details.
'*
'* You should have received a copy of the GNU General Public License
'* along with this program; if not, write to the Free Software
'* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
Option Strict On

Imports System.ComponentModel
Imports System.Configuration.Install

<RunInstaller(True)> Public Class ProjectInstaller
    Inherits System.Configuration.Install.Installer

#Region " Component Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Component Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Installer overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Component Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Component Designer
    'It can be modified using the Component Designer.  
    'Do not modify it using the code editor.
  Friend WithEvents ServiceProcessInstaller1 As System.ServiceProcess.ServiceProcessInstaller
  Friend WithEvents ServiceInstaller1 As System.ServiceProcess.ServiceInstaller
  <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
    Me.ServiceProcessInstaller1 = New System.ServiceProcess.ServiceProcessInstaller
    Me.ServiceInstaller1 = New System.ServiceProcess.ServiceInstaller
    '
    'ServiceProcessInstaller1
    '
    Me.ServiceProcessInstaller1.Account = System.ServiceProcess.ServiceAccount.LocalSystem        '
    Me.ServiceProcessInstaller1.Password = Nothing
    Me.ServiceProcessInstaller1.Username = Nothing
    '
    'ServiceInstaller1
    '
    Me.ServiceInstaller1.DisplayName = "xPL VIOM"        
    Me.ServiceInstaller1.ServiceName = "xPLVIOM"
    Me.ServiceInstaller1.StartType = System.ServiceProcess.ServiceStartMode.Automatic
    '
    'ProjectInstaller
    '
    Me.Installers.AddRange(New System.Configuration.Install.Installer() {Me.ServiceProcessInstaller1, Me.ServiceInstaller1})

  End Sub

#End Region

  Private Sub ServiceInstaller1_BeforeUninstall(ByVal sender As Object, ByVal e As System.Configuration.Install.InstallEventArgs) Handles ServiceInstaller1.BeforeUninstall
    Try
      Dim myService As New ServiceProcess.ServiceController("xplviom")
      If Not myService.Status = ServiceProcess.ServiceControllerStatus.Stopped Then
        myService.Stop()
        myService.WaitForStatus(ServiceProcess.ServiceControllerStatus.Stopped, New TimeSpan(0, 0, 30))
      End If
    Catch ex As Exception
    End Try
    ' Delete the XML file
    Try
      File.Delete(Environment.SystemDirectory & "\xpl_johnb-viom.instance1.xml")
    Catch ex As Exception
    End Try
  End Sub

  Private Sub ServiceInstaller1_AfterInstall(ByVal sender As Object, ByVal e As System.Configuration.Install.InstallEventArgs) Handles ServiceInstaller1.AfterInstall
    Try
      Dim myService As New ServiceProcess.ServiceController("xplviom")
      myService.Start()
    Catch ex As Exception
    End Try
  End Sub

  Public Overrides Sub Install(ByVal _
   stateSaver As _
   System.Collections.IDictionary)    
    MyBase.Install(stateSaver)
    CheckForHub()
    Try
      Dim port As String = MyBase.Context.Parameters("PORT")
      If port = "2" Or port = "3" Then
        ' Create an XML configuration document
        Dim filename As String = Environment.SystemDirectory & "\xpl_johnb-viom.instance1.xml"
        Dim instanceName As String = Environment.MachineName
        Dim xml As New XmlTextWriter(filename, Nothing)
        If instanceName.Length > 16 Then
          instanceName = instanceName.Substring(0, 16)
        End If
        instanceName = instanceName.Replace("-", "").Replace("_", "")
        xml.Formatting = Formatting.Indented
        xml.WriteStartDocument(False)
        xml.WriteStartElement("xplConfiguration")

        ' SOurce
        xml.WriteStartElement("instance")
        xml.WriteAttributeString("value", Environment.MachineName)
        xml.WriteEndElement()

        ' COnfig items
        xml.WriteStartElement("configItems")
        xml.WriteStartElement("configItem")
        xml.WriteAttributeString("key", "comport")
        xml.WriteAttributeString("value", (CInt(port) - 1).ToString)
        xml.WriteEndElement()
        xml.WriteEndElement()

        xml.WriteEndElement()
        xml.WriteEndDocument()
        xml.Close()
      End If
    Catch ex As Exception
      MsgBox("There was a problem configuring xPL VIOM:" & vbCrLf & ex.ToString, vbCritical)
    End Try
  End Sub

  Private Sub CheckForHub()
    ' This routine tries to bind to 3865 UDP.
    ' If it can bind, it assumes that a hub isn't warning and
    ' pops up a box to warn the user.
    Try
      Dim sock As New Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp)
      sock.Bind(New ipendpoint(ipaddress.any, 3865))
      sock.Close()
      MsgBox("Setup detected that no xPL Hub is currently running on this computer." & vbCrLf & "This application requires that an xPL Hub be installed and running before it will operate successfully." & vbCrLf & vbCrLf & "Please see www.xplproject.org.uk for a suitable xPL Hub for your environment.", vbInformation, "xPL Hub Not Found")
    Catch ex As Exception
      ' Bind failed, so hub must be running.      
    End Try
  End Sub

End Class
